<?php

App::uses('EvNewsletterSignupsAppController', 'EvNewsletterSignups.Controller');

class SignupsController extends EvNewsletterSignupsAppController {

	/**
	 * beforeFilter callback, redefine to allow adminAction
	 *
	 */
	public function beforeFilter() {
		$this->adminActions[] = 'admin_export';

		parent::beforeFilter();
	}

	/**
	 * export all the signups to csv
	 */
	public function admin_export() {
		// process the headers
		$extraFields = Configure::read('EvNewsletterSignups.extraFields');

		$_header = array('Email');
		foreach ($extraFields as $name => $attr) {
			if (! empty($attr['label']) && ! is_array($attr['label'])) {
				$_header[] = $attr['label'];
			} elseif (! empty($attr['label']['label'])) {
				$_header[] = $attr['label']['label'];
			} else {
				$_header[] = InflectorExt::humanize($name);
			}
		}

		// process the signups
		$data = array();
		$signups = $this->Signup->find('all');
		$extraFieldNames = array_keys($extraFields);

		foreach ($signups as $item) {
			$row = array();
			$row[] = $item['Signup']['email'];

			foreach ($extraFieldNames as $field) {
				if (! empty($item['Signup']['extras'][$field])) {
					$row[] = $item['Signup']['extras'][$field];
				} else {
					$row[] = '';
				}
			}

			$data[] = $row;
		}

		$_serialize = 'data';

		$this->viewClass = 'CsvView.Csv';
		$this->set(compact('data', '_serialize', '_header'));
		$this->response->download('Newsletter-Signups-' . date("j-M-Y") . '.csv');
	}

}
